package org.gcube.application.cms.commons.model.concessioni;

import static org.junit.Assert.assertEquals;

import org.gcube.application.cms.tests.model.concessioni.TestConcessioniModel;
import org.gcube.application.geoportal.common.model.legacy.Concessione;
import org.gcube.application.geoportal.common.model.legacy.Concessione.Paths;
import org.gcube.application.geoportal.common.model.legacy.LayerConcessione;
import org.gcube.application.geoportal.common.model.legacy.RelazioneScavo;
import org.gcube.application.geoportal.common.model.legacy.UploadedImage;
import org.junit.Assert;
import org.junit.Test;


public class PathsTest {

	
	@Test
	public void embeddedPaths() {
		Concessione c= TestConcessioniModel.prepareConcessione();
		c= TestConcessioniModel.setIds(c);
		
		
		
		LayerConcessione p=(LayerConcessione) c.getContentByPath(Paths.POSIZIONAMENTO);
		Assert.assertEquals(c.getPosizionamentoScavo(), p);
		
		RelazioneScavo rel=(RelazioneScavo) c.getContentByPath(Paths.RELAZIONE);
		Assert.assertEquals(c.getRelazioneScavo(), rel);
		
		for(int i=0;i<c.getPianteFineScavo().size();i++) {
			LayerConcessione l=(LayerConcessione) c.getContentByPath(Paths.piantaByIndex(i));
			Assert.assertEquals(c.getPianteFineScavo().get(i),l);
		}
		
		for(int i=0;i<c.getImmaginiRappresentative().size();i++) {
			UploadedImage l=(UploadedImage) c.getContentByPath(Paths.imgByIndex(i));
			Assert.assertEquals(c.getImmaginiRappresentative().get(i),l);
		}
		
		
		for(int i=0;i<c.getPianteFineScavo().size();i++) {
			LayerConcessione layer=c.getPianteFineScavo().get(i);
			LayerConcessione l=(LayerConcessione) c.getContentByPath(Paths.piantaById(layer.getMongo_id()));
			Assert.assertEquals(layer,l);
		}
		
		
		
		for(int i=0;i<c.getImmaginiRappresentative().size();i++) {
			UploadedImage layer=c.getImmaginiRappresentative().get(i);
			UploadedImage l=(UploadedImage) c.getContentByPath(Paths.imgById(layer.getMongo_id()));
			Assert.assertEquals(layer,l);
		}
		
		
		System.out.println();
		System.out.println();
		
		
		
		
	}

	
	
}
